package com.gxwebsoft.apps.controller;

import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.gxwebsoft.apps.entity.BcPlan;
import com.gxwebsoft.apps.param.BcPlanParam;
import com.gxwebsoft.apps.service.BcPlanService;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

/**
 * 菜品发布管理控制器
 *
 * @author 科技小王子
 * @since 2023-04-27 17:59:40
 */
@Api(tags = "菜品发布管理管理")
@RestController
@RequestMapping("/api/apps/bc-plan")
public class BcPlanController extends BaseController {
    @Resource
    private BcPlanService bcPlanService;

    @PreAuthorize("hasAuthority('apps:bcPlan:list')")
    @OperationLog
    @ApiOperation("分页查询菜品发布管理")
    @GetMapping("/page")
    public ApiResult<PageResult<BcPlan>> page(BcPlanParam param) {
        // 使用关联查询
        return success(bcPlanService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('apps:bcPlan:list')")
    @OperationLog
    @ApiOperation("查询全部菜品发布管理")
    @GetMapping()
    public ApiResult<List<BcPlan>> list(BcPlanParam param) {
        // 使用关联查询
        return success(bcPlanService.listRel(param));
    }

    @PreAuthorize("hasAuthority('apps:bcPlan:list')")
    @OperationLog
    @ApiOperation("根据id查询菜品发布管理")
    @GetMapping("/{id}")
    public ApiResult<BcPlan> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(bcPlanService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('apps:bcPlan:save')")
    @OperationLog
    @ApiOperation("添加菜品发布管理")
    @PostMapping()
    public ApiResult<?> save(@RequestBody BcPlan bcPlan) {
        // 记录当前登录用户id、租户id、商户编号
        User loginUser = getLoginUser();
        if (loginUser != null) {
          bcPlan.setUserId(loginUser.getUserId());
        }
        if(bcPlanService.count(new LambdaQueryWrapper<BcPlan>().eq(BcPlan::getDayTime, bcPlan.getDayTime())) > 0){
          return fail("当天已发布过菜品");
        }
        bcPlan.setWeek(DateUtil.dayOfWeek(bcPlan.getDayTime()) - 1);
        if (bcPlanService.save(bcPlan)) {
              return success("发布成功");
        }
        return fail("发布失败");
    }

    @PreAuthorize("hasAuthority('apps:bcPlan:update')")
    @OperationLog
    @ApiOperation("修改菜品发布管理")
    @PutMapping()
    public ApiResult<?> update(@RequestBody BcPlan bcPlan) {
      System.out.println("bcPlan = " + bcPlan);
      final Date dayTime = bcPlan.getDayTime();
      System.out.println("dayTime = " + dayTime);
      final int week = DateUtil.dayOfWeek(dayTime);
      bcPlan.setWeek(week - 1);
      if (bcPlanService.updateById(bcPlan)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('apps:bcPlan:remove')")
    @OperationLog
    @ApiOperation("删除菜品发布管理")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (bcPlanService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('apps:bcPlan:save')")
    @OperationLog
    @ApiOperation("批量添加菜品发布管理")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<BcPlan> list) {
        if (bcPlanService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('apps:bcPlan:update')")
    @OperationLog
    @ApiOperation("批量修改菜品发布管理")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<BcPlan> batchParam) {
        if (batchParam.update(bcPlanService, "bc_plan_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('apps:bcPlan:remove')")
    @OperationLog
    @ApiOperation("批量删除菜品发布管理")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (bcPlanService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
